<?php

	require_once(PATH_t3lib . "class.t3lib_extmgm.php");

	class formlets_tools
	{
		function _renderInfos()
		{
			$aHtml = array();

			$aFormidable	= $this->_extractExtensionsInfos(array(array("EXTKEY" => "ameos_formidable")));
			$aRenderlets	= $this->_extractExtensionsInfos($GLOBALS["TYPO3_CONF_VARS"]["EXTCONF"]["ameos_formidable"]["renderlets"]);
			$aValidators	= $this->_extractExtensionsInfos($GLOBALS["TYPO3_CONF_VARS"]["EXTCONF"]["ameos_formidable"]["validators"]);
			$aRenderers		= $this->_extractExtensionsInfos($GLOBALS["TYPO3_CONF_VARS"]["EXTCONF"]["ameos_formidable"]["renderers"]);
			$aDataHandlers	= $this->_extractExtensionsInfos($GLOBALS["TYPO3_CONF_VARS"]["EXTCONF"]["ameos_formidable"]["datahandlers"]);
			$aActionlets	= $this->_extractExtensionsInfos($GLOBALS["TYPO3_CONF_VARS"]["EXTCONF"]["ameos_formidable"]["actionlets"]);

			$aHtml[] = "<H3>FORMidable CORE</H3>";
			$aHtml[] = $this->_renderExtList($aFormidable);

			$aHtml[] = "<H3>Installed RENDERLETS</H3>";
			$aHtml[] = $this->_renderExtList($aRenderlets);

			$aHtml[] = "<H3>Installed VALIDATORS</H3>";
			$aHtml[] = $this->_renderExtList($aValidators);

			$aHtml[] = "<H3>Installed RENDERERS</H3>";
			$aHtml[] = $this->_renderExtList($aRenderers);

			$aHtml[] = "<H3>Installed DATAHANDLERS</H3>";
			$aHtml[] = $this->_renderExtList($aDataHandlers);

			$aHtml[] = "<H3>Installed ACTIONLETS</H3>";
			$aHtml[] = $this->_renderExtList($aActionlets);

			return implode("", $aHtml);
		}

		function _extractExtensionsInfos($aDeclaredExts)
		{
			$aExts = array();
			
			reset($aDeclaredExts);
			while(list(, $aInfos) = each($aDeclaredExts))
			{
				$extsrcpath = t3lib_extmgm::extPath($aInfos["EXTKEY"]);
				
				$_EXTKEY = $aExt["extkey"];
				include($extsrcpath . "ext_emconf.php");

				$aExt = array();
				$aExt["srcpath"]	= $extsrcpath;
				$aExt["extkey"]		= $aInfos["EXTKEY"];
				$aExt["type"]		= $aInfos["TYPE"];
				$aExt["emconf"]		= $EM_CONF[$_EXTKEY];

				$aExts[] = $aExt;
			}

			reset($aExts);
			return $aExts;
		}

		function _renderExtList($aExts)
		{
			$aHtml = array();
			
			reset($aExts);
			while(list(, $aExt) = each($aExts))
			{
				$aDep = t3lib_div::trimExplode(",", $aExt["emconf"]["dependencies"]);

				reset($aDep);
				while(list($key, $dep) = each($aDep))
				{
					if(strtolower($dep) == "cms")
					{ unset($aDep[$key]);}
					else
					{ $aDep[$key] = "<a href = 'http://www.typo3.org/extensions/repository/search/" . $dep . "/' target = '_blank'>" . $dep . "</a>";}
				}

				$aHtml[] = "<table border = '0' cellspacing = '0' cellpadding = '0' width = '500'>";
				$aHtml[] = "<tr><td width = '80%'>";
				$aHtml[] = "<table border = '0' cellpadding = '5' cellspacing = '0' width = '100%'>";
				$aHtml[] = "<tr><td rowspan = '3' valign = 'top' width = '18px'><img src = '" . str_replace($GLOBALS["_SERVER"]["DOCUMENT_ROOT"], "", $aExt["srcpath"]) . "ext_icon.gif'></td></tr>";

				$type = "";

				if($aExt["type"] != "")
				{ $type = " ( type " . $aExt["type"] . " )";}

				$title = $aExt["emconf"]["title"];
				if($aExt["extkey"] != "ameos_formidable")
				{ $title = ucwords(trim(str_replace("ameos formidable -", "", strtolower($title))));}

				$aHtml[] = "<tr><td>";
				$aHtml[] = $aExt["object"] . " <strong>" . $title . $type . "</strong><br>";
				$aHtml[] = "(" . $aExt["extkey"] . " v. " . $aExt["emconf"]["version"] . " )<br>";
				$aHtml[] = "Dep. : " . implode(", ", $aDep) . "<br><br>";
				$aHtml[] = "<i style = 'background-color: yellow'>&nbsp;" . $aExt["emconf"]["description"] . "&nbsp;</i><br>";
				$aHtml[] = "</td></tr>";
				
				$aHtml[] = "</table>";
				$aHtml[] = "</td><td width = '20%' valign = 'middle'>";
				
				if(file_exists($aExt["srcpath"] . "sampleconf.xml"))
				{ $aHtml[] = "<a href = '" . str_replace($GLOBALS["_SERVER"]["DOCUMENT_ROOT"], "", $aExt["srcpath"]) . "sampleconf.xml' target = 'sampleconf'><img src = '../../../../t3lib/gfx/fileicons/xml.gif' border = '0' hspace = '3'>Sample</a>";}

				$aHtml[] = "</td></tr></table>";

				$aHtml[] = "<br>";


	//			$aHtml[] = "<hr style = 'height: 2px; border-color: orange; border-style: dashed'>";
			}
			
			return implode("\n", $aHtml);
		}
	}

?>