<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Jrme Schneider (typo3dev@ameos.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Module 'FORMidable' for the 'ameos_formidable' extension.
 *
 * @author    Jrme Schneider <typo3dev@ameos.com>
 */



    // DEFAULT initialization of a module [BEGIN]

unset($MCONF);    
require ("conf.php");
require ($BACK_PATH."init.php");
require ($BACK_PATH."template.php");
$LANG->includeLLFile("EXT:ameos_formidable/mod1/locallang.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
require_once (PATH_t3lib."class.t3lib_basicfilefunc.php");
require_once (PATH_t3lib."class.t3lib_install.php");
require_once (PATH_t3lib."class.t3lib_extmgm.php");
require_once (t3lib_extmgm::extPath("ameos_formidable") . "mod1/class.formlets_tools.php");

$BE_USER->modAccess($MCONF,1);    // This checks permissions and exits if the users has no permission for entry.
    
	// DEFAULT initialization of a module [END]

class tx_ameosformidable_module1 extends t3lib_SCbase
{
	var $pageinfo;
	var $oFormletsTools = null;
	
	function init()
	{
		global $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $CLIENT, $TYPO3_CONF_VARS;
		$this->oFormletsTools = new formlets_tools();
		parent::init();
    }

    /**
     * Adds items to the ->MOD_MENU array. Used for the function menu selector.
     */

    function menuConfig()
	{
		global $LANG;
		
		$this->MOD_MENU = Array(
            "function" => Array (
                "1" =>	"INSTALL FORMIDABLE",
                "2" =>	"INFORMATIONS",
				"3"	=>	"API DOCUMENTATION",
            )
        );
		
		parent::menuConfig();
    }
	
	/**
	* Main function of the module. Write the content to $this->content
	*/

	function main()
	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
        
        // Access check!
        // The page will show only if there is a valid page and if this page may be viewed by the user
        $this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
        $access = is_array($this->pageinfo) ? 1 : 0;
        
        if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))    {
    
                // Draw the header.
            $this->doc = t3lib_div::makeInstance("mediumDoc");
            $this->doc->backPath = $BACK_PATH;
            $this->doc->form='<form action="" method="POST">';

                // JavaScript
            $this->doc->JScode = '
                <script language="javascript" type="text/javascript">
                    script_ended = 0;
                    function jumpToUrl(URL)    {
                        document.location = URL;
                    }
                </script>
            ';
            $this->doc->postCode='
                <script language="javascript" type="text/javascript">
                    script_ended = 1;
                    if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
                </script>
            ';

            $headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

            $this->content.=$this->doc->startPage($LANG->getLL("title"));
            $this->content.=$this->doc->header($LANG->getLL("title"));
            $this->content.=$this->doc->spacer(5);
            $this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
            $this->content.=$this->doc->divider(5);

            
            // Render content:
            $this->moduleContent();

            
            // ShortCut
            if ($BE_USER->mayMakeShortcut())    {
                $this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
            }
        
            $this->content.=$this->doc->spacer(10);
        } else {
                // If no access or if ID == zero
        
            $this->doc = t3lib_div::makeInstance("mediumDoc");
            $this->doc->backPath = $BACK_PATH;
        
            $this->content.=$this->doc->startPage($LANG->getLL("title"));
            $this->content.=$this->doc->header($LANG->getLL("title"));
            $this->content.=$this->doc->spacer(5);
            $this->content.=$this->doc->spacer(10);
        }
    }

    /**
     * Prints out the module HTML
     */
    function printContent()    {

        $this->content.=$this->doc->endPage();
        echo $this->content;
    }
    
    /**
     * Generates the module content
     */
    function moduleContent()
	{
		switch((string)$this->MOD_SETTINGS["function"])    {
            case 1:
                $this->content .= $this->_renderInstall();
            break;
			case 2:
                $this->content .= $this->oFormletsTools->_renderInfos();
            break;
            case 3:
                $this->content .= $this->_renderAPIDoc();
            break;
        } 
    }
	
	function _renderAPIDoc()
	{
		$aHtml = array();
		$aHtml[] = "<h2>API Documentation</h2>";
		$aHtml[] = "<h3>&#149; <a href = \"javascript:void(window.open('doc/class.tx_ameosformidable_pi1.php.html'))\">pi1/tx_ameosformidable_pi1.php</a></h3>";

		return implode("\n", $aHtml);
	}
	
	function _renderInstall()
	{
		$oFile = t3lib_div::makeInstance("t3lib_basicFileFunctions");
		
		$aHtml = array();
		$aExtToInstall = array();
		
		$aXml = t3lib_div::xml2array(implode("", file(t3lib_extmgm::extPath("ameos_formidable") . "mod1/install/formidable_install.xml")));
		$aXml["srcpath"] = t3lib_div::getFileAbsFileName($aXml["srcpath"]);

		// on vrifie que toutes les extensions sont installes
		reset($aXml["extensions"]);
		
		while(list(, $aExt) = each($aXml["extensions"]))
		{
			$extsrcpath = $oFile->slashPath($oFile->rmDoubleSlash($aXml["srcpath"])) . $aExt["extkey"] . "/";
			$destpath = $oFile->slashPath($oFile->rmDoubleSlash($oFile->slashPath(realpath(t3lib_extmgm::extPath("ameos_formidable") . "../")) . $aExt["extkey"]));

			$_EXTKEY = $aExt["extkey"];
			include($extsrcpath . "ext_emconf.php");
			
			$aExt["srcpath"]	= $extsrcpath;
			$aExt["destpath"]	= $destpath;
			$aExt["emconf"]		= $EM_CONF[$_EXTKEY];

			if(!$this->isInstalled($aExt) && $oFile->is_directory($aExt["destpath"]) === false)
			{ $aExtToInstall[] = $aExt;}
		}
		
		if($this->_installMode())
		{
			// on installe les extensions

			$aLog = array();

			reset($aExtToInstall);
			while(list(, $aExt) = each($aExtToInstall))
			{
				if(!$this->isInstalled($aExt["extkey"]))
				{ $aLog[] = $this->_installExt($aExt);}
			}
			
			$aHtml[] = "<h3>EXTENSIONS HAVE BEEN INSTALLED !!</h3>";
			$aHtml[] = implode("", file(t3lib_extmgm::extPath("ameos_formidable") . "mod1/install/whatsnext.html"));
			$aHtml[] = "<h3>Install Log :</h3>";
			$aHtml[] = "<ul><li>" . implode("</li><li>", $aLog) . "</li></ul>";

			$aNewExtensionList = t3lib_div::trimExplode(",", $GLOBALS["TYPO3_CONF_VARS"]['EXT']['extList']);

			reset($aExtToInstall);
			while(list(, $aExt) = each($aExtToInstall))
			{
				if(!in_array($aExt["extkey"], $aNewExtensionList))
				{ $aNewExtensionList[] = $aExt["extkey"];}
			}

			reset($aNewExtensionList);
			$this->writeNewExtensionList(implode(",", $aNewExtensionList));
		}
		else
		{
			if(sizeof($aExtToInstall) > 0)
			{
				// on affiche les extensions  installer
				$aHtml[] = "<h3>FOLLOWING FORMIDABLE ELEMENTS WILL BE INSTALLED</h3>";
				$aHtml[] = "<input type = \"button\" onclick = \"javascript:void(document.location.href='?&SET[function]=1&PROCEEDINSTALL=1')\" value = \"Install now !\"><br>";
				$aHtml[] = $this->oFormletsTools->_renderExtList($aExtToInstall);
				$aHtml[] = "<input type = \"button\" onclick = \"javascript:void(document.location.href='?&SET[function]=1&PROCEEDINSTALL=1')\" value = \"Install now !\">";
			}
			else
			{
				// on affiche qu'il n'y a aucune extension  installer
				$aHtml[] = "<h3>!! EVERYTHING IS INSTALLED !!</h3>";
				$aHtml[] = implode("", file(t3lib_extmgm::extPath("ameos_formidable") . "mod1/install/whatsnext.html"));
			}
		}

		return implode("<br>", $aHtml);
	}

	function isInstalled($aExt)
	{
		$aInstalledExt = t3lib_div::trimExplode(",", $GLOBALS["TYPO3_CONF_VARS"]['EXT']['extList']);
		return (in_array($aExt["extkey"], $aInstalledExt));
	}
	
	function _installMode()
	{ return (array_key_exists("PROCEEDINSTALL", $GLOBALS["HTTP_GET_VARS"]) && intval($GLOBALS["HTTP_GET_VARS"]["PROCEEDINSTALL"]) == 1);}

	function _installExt($aExt)
	{
		$oFile = t3lib_div::makeInstance("t3lib_basicFileFunctions");

		$extsrcpath = $aExt["srcpath"];
		$destpath = $aExt["destpath"];
		
//		debug(array("SRC" => $extsrcpath, "DEST" => $destpath));
		
		$ok = "<span style = 'color: green; font-weight: bold'>OK</span> : ";
		$nok = "<span style = 'color: red; font-weight: bold'>! NOT OK !</span> : ";
		
		if($oFile->is_directory($extsrcpath) !== false)
		{
			if($oFile->is_directory($destpath) === false)
			{
				$msg = $ok . "INSTALL " . $extkey . "<br><b>from : </b>" . $extsrcpath . "<br><b>to&nbsp;&nbsp; : </b>" . $destpath;

				// on copie le rpertoire depuis $extsrcpath vers $destpath
				$this->copyr($extsrcpath, $destpath);
			}
			else
			{
				// le rpertoire de l'extension existe dj sur le serveur
				$msg = $nok . "EXT DIRECTORY " . $extkey . " ALREADY EXISTS";
			}
		}
		else
		{
			// l'extension  installer n'existe pas dans EXT:ameos_formidable/mod1/install/ext/
			$msg = $nok . "PACKAGE <b>" . $extsrcpath . "</b> TO INSTALL DOESN'T EXISTS IN THE INSTALL DIR";
		}

		return $msg;
	}
	
	/** 
	 * Copy a file, or recursively copy a folder and its contents 
	 * 
	 * @author      Aidan Lister <aidan@php.net> 
	 * @version     1.0.1 
	 * @link        http://aidanlister.com/repos/v/function.copyr.php 
	 * @param       string   $source    Source path 
	 * @param       string   $dest      Destination path 
	 * @return      bool     Returns TRUE on success, FALSE on failure 
	 */ 
	function copyr($source, $dest) 
	{ 
		// Simple copy for a file 
		if (is_file($source)) { 
			return copy($source, $dest); 
		} 
	  
		// Make destination directory 
		if (!is_dir($dest)) { 
			mkdir($dest); 
		} 
	  
		// Loop through the folder 
		$dir = dir($source);
		while (($entry = $dir->read()) !== false) { 
			// Skip pointers 
			if ($entry == '.' || $entry == '..') { 
				continue; 
			} 
	  
			// Deep copy directories 
			if ($dest !== "$source/$entry") { 
				$this->copyr("$source/$entry", "$dest/$entry"); 
			} 
		} 
	  
		// Clean up 
		$dir->close(); 
		return true; 
	}


	/**
	 * Writes the extension list to "localconf.php" file
	 * Removes the temp_CACHED* files before return.
	 *
	 * @param	string		List of extensions
	 * @return	void
	 */
	function writeNewExtensionList($newExtList)	{

			// Instance of install tool
		$instObj = new t3lib_install;
		$instObj->allowUpdateLocalConf =1;
		$instObj->updateIdentity = 'TYPO3 Extension Manager';

			// Get lines from localconf file
		$lines = $instObj->writeToLocalconf_control();
		$instObj->setValueInLocalconfFile($lines, '$TYPO3_CONF_VARS[\'EXT\'][\'extList\']', $newExtList);
		$instObj->writeToLocalconf_control($lines);

		$this->removeCacheFiles();
	}

	/**
	 * Unlink (delete) cache files
	 *
	 * @return	integer		Number of deleted files.
	 */
	function removeCacheFiles()	{
		$cacheFiles = t3lib_extMgm::currentCacheFiles();
		$out = 0;
		if (is_array($cacheFiles))	{
			reset($cacheFiles);
			while(list(,$cfile) = each($cacheFiles))	{
				@unlink($cfile);
				clearstatcache();
				$out++;
			}
		}
		return $out;
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/mod1/index.php"])    {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/mod1/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_ameosformidable_module1");
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)    include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>