<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Jrme Schneider (typo3dev@ameos.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'ameos_formidable_act_mail' for the 'ameos_formidable_act_mail' extension.
 *
 * @author	Jrme Schneider <typo3dev@ameos.com>
 */


require_once(PATH_t3lib . "class.t3lib_htmlmail.php");

class tx_ameosformidableactmail_pi1 extends formidable_mainactionlet
{
	function _doTheMagic($aRendered, $sForm)
	{
		$aCreation	= $this->oForm->_navConf("/conf/creation/", $this->aConf);
		$aEdition	= $this->oForm->_navConf("/conf/edition/", $this->aConf);

		if($this->oForm->oDataHandler->_isSubmitted() && $this->oForm->oDataHandler->_allIsValid())
		{
			$edition = $this->oForm->oDataHandler->_edition();
			
			if($edition)
			{
				// FORMidable is in edition mode
				
				if($aEdition)
				{ $this->_sendMail($aEdition);}
			}
			else
			{
				// FORMidable is in creation mode

				if($aCreation)
				{ $this->_sendMail($aCreation);}
			}
		}
	}

	function _sendMail($aConf)
	{
		$aHRData = $this->_getHumanFormData();

		$this->oForm->_debug(array("conf" => $aConf, "human_readable_data" => $aHRData), "ACTIONLET MAIL - EXECUTION", __LINE__, __FILE__);

		$template_path	= t3lib_div::getFileAbsFileName($this->oForm->_navConf("/template/path/", $aConf));
		$form_subpart	= $this->oForm->_navConf("/template/subparts/form/", $aConf);
		
		$sMail = $this->_parseTemplate($template_path, $form_subpart, $aHRData["labels"], $aHRData["values"]);
		
		$aAddresses = t3lib_div::trimExplode(",", $this->oForm->_navConf("/addresses/", $aConf));
		$isHtml		= (strtoupper($this->oForm->_navConf("/html/", $aConf)) == "TRUE");
		
		$subject	= $this->oForm->_navConf("/subject/", $aConf);
		
		$fromEmail	= $this->oForm->_navConf("/fromemail/", $aConf);
		$fromName	= $this->oForm->_navConf("/fromname/", $aConf);

		$replyToEmail	= $this->oForm->_navConf("/replytoemail/", $aConf);
		$replyToName	= $this->oForm->_navConf("/replytoname/", $aConf);

		
		$oMail = t3lib_div::makeInstance('t3lib_htmlmail');
		$oMail->start();
		$oMail->useBase64();

		$oMail->subject			= $subject;
		$oMail->from_email		= $fromEmail;
		$oMail->from_name		= $fromName;
		$oMail->replyto_email	= $replyToEmail ? $replyToEmail : $fromEmail;
		$oMail->replyto_name	= $replyToName ? $replyToName : $fromName;
		$oMail->organisation	= '';
		$oMail->priority		= 3;

		if($isHtml)
		{
			// HTML
			$oMail->theParts['html']['content'] = $sMail;	// Fetches the content of the page
			$oMail->theParts['html']['path'] = '';
			$oMail->extractMediaLinks();
			$oMail->extractHyperLinks();
			$oMail->fetchHTMLMedia();
			$oMail->substMediaNamesInHTML(0);	// 0 = relative
			$oMail->substHREFsInHTML();
			$oMail->setHTML($oMail->encodeMsg($oMail->theParts['html']['content']));
		}
		else
		{
			// PLAIN
			$oMail->addPlain($sMail);
		}
		
		// SET Headers and Content
		$oMail->setHeaders();
		$oMail->setContent();
		$oMail->setRecipient($aAddresses);


		$oMail->sendtheMail();
	}
	
	function _getHumanFormData()
	{
		$aFormData = $this->oForm->oDataHandler->_getFormData();
		
		$aValues = array();
		$aLabels = array();

		reset($aFormData);
		while(list($elementname, $value) = each($aFormData))
		{
			$aValues[$elementname] = $this->oForm->aORenderlets[$elementname]->_getHumanReadableValue($value);
			$aLabels[$elementname] = $this->oForm->_getLLLabel($this->oForm->aORenderlets[$elementname]->aElement["conf"]["label"]);
		}

		reset($aValues);
		reset($aLabels);

		return array(	"labels"	=> $aLabels,
						"values"	=> $aValues
						);
	}

	function _parseTemplate($templatePath, $templateMarker, $aTagsLabels = array(), $aTagsValues = array())
	{
		// $tempUrl : the path of the template for use with t3lib_div::getUrl()
		// $tempMarker :  the template subpart marker
		// $aTags : the marker array for substitution
		
		$templateCode = t3lib_div::getUrl($templatePath);
		$template = t3lib_parsehtml::getSubpart($templateCode, $templateMarker);
		
		reset($aTagsLabels);
		while(list($elementname, $valeur) = each($aTagsLabels))
		{
			$tag = "[" . $elementname . "]";
			$template = str_replace($tag, $valeur, $template);
		}
		
		$template = ereg_replace("\[[a-zA-Z0-9_]*]", "", $template);
		
		reset($aTagsValues);
		while(list($elementname, $valeur) = each($aTagsValues))
		{
			$tag = "{" . $elementname . "}";
			$template = str_replace($tag, $valeur, $template);
		}
		
		return ereg_replace("\{[a-zA-Z0-9_]*}", "", $template);
	}
}

?>