<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Jrme Schneider (typo3dev@ameos.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'ameos_formidable_dh_db' for the 'ameos_formidable_dh_db' extension.
 *
 * @author	Jrme Schneider <typo3dev@ameos.com>
 */

class tx_ameosformidabledhdb_pi1 extends formidable_maindatahandler
{
	function _doTheMagic()
	{
		if($this->_allIsValid())
		{
			// il n'y a aucune erreur de validation
			// on peut traiter les donnes
			
			$aVars = array();
			$aConf = $this->oForm->_navConf("/control/datahandler/");
			
			if($this->_isSubmitted())
			{
				// on met  jour / insre l'enregistrement dans la base de donnes
				
				$tablename	= $this->oForm->_navConf("/control/datahandler/conf/tablename");
				$keyname	= $this->oForm->_navConf("/control/datahandler/conf/keyname");

				$aRs = array();
				$aFormData = $this->_getFormDataManaged();

				reset($aFormData);
				while(list($elementname, $value) = each($aFormData))
				{
					$oRenderlet = $this->oForm->aORenderlets[$elementname];
					$aRs[$elementname] = $oRenderlet->_fromRenderletToDataHandler($value, $oRenderlet->aElement);
				}
				
				if($tablename != "" && $keyname != "")
				{
					$db = $GLOBALS["TYPO3_DB"];

					$editEntry = $this->_edition();

					if($editEntry)
					{
						// on met les donnes  jour
						
						$this->oForm->_debug($aRs, "EXECUTION DU DATAHANDLER DB - EDITION !! " . $tablename . "[" . $editEntry . "]", __LINE__, __FILE__);
						$db->exec_UPDATEquery($tablename, $keyname . " = '" . $editEntry . "'", $aRs);
					}
					else
					{
						// on insre les donnes
						
						$this->oForm->_debug($aRs, "EXECUTION DU DATAHANDLER DB - INSERTION !! " . $tablename, __LINE__, __FILE__);
						$db->exec_INSERTquery($tablename, $aRs);
						
						$this->entryId = $db->sql_insert_id();
					}
				}
				else
				{ $oForm->mayday("DATAHANDLER configuration isn't correct");}
			}
		}
	}

	function _edition()
	{
		$aVars = $this->_GP();
		$editkey = AMEOSFORMIDABLE_ENTRYID;

		if(array_key_exists($editkey, $aVars) && $aVars[$editkey] != "")
		{ return $aVars[$editkey];}

		return false;
	}

	function _getFormData()
	{
		if($this->_isSubmitted())
		{
			// the form has been submitted
			// fall back to default data process

			return parent::_getFormData();
		}
		else
		{
			$tablename	= $this->oForm->_navConf("/control/datahandler/conf/tablename");
			$keyname	= $this->oForm->_navConf("/control/datahandler/conf/keyname");
			
			if($this->_edition())
			{
				// le formulaire est affich pour la premire fois
				// on va chercher les informations dans la base de donnes

				if($tablename != "" && $keyname != "")
				{
					reset($this->aStoredData);
					return $this->aStoredData;
				}
				else
				{ $this->oForm->mayday("DATAHANDLER configuration isn't correct");}
			}
		}

		// le formulaire n'est ni soumis, ni dit
		return array();
	}

	function _getStoredData()
	{
		$tablename	= $this->oForm->_navConf("/control/datahandler/conf/tablename");
		$keyname	= $this->oForm->_navConf("/control/datahandler/conf/keyname");

		$editid = $this->_edition();
		
		$db = $GLOBALS["TYPO3_DB"];
		$rSql = $db->exec_SELECTquery("*", $tablename, $keyname . " = '" . $editid . "'");

		if(($aRs = $db->sql_fetch_assoc($rSql)) !== false)
		{
			// on va rechercher la configuration du champ en question
			$aElements = $this->oForm->_navConf("/elements/");

			while(list($itemindex, $aItemInfos) = each($aElements))
			{
				$elementname = $this->oForm->_navConf("/elementname/", $aItemInfos);
				$oRenderlet = $this->oForm->aORenderlets[$elementname];

				$confirm_element = $this->oForm->_navConf("/conf/confirm", $oRenderlet->aElement);
				
				if($confirm_element)
				{ $aRs[$elementname] = $oRenderlet->_fromDataHandlerToRenderlet($aRs[$confirm_element]);}
				else
				{ $aRs[$elementname] = $oRenderlet->_fromDataHandlerToRenderlet($aRs[$elementname]);}
			}
		}
		
		return $aRs;
	}
}

?>