<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Jrme Schneider (typo3dev@ameos.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'ameos_formidable_rdt_checkbox' for the 'ameos_formidable_rdt_checkbox' extension.
 *
 * @author	Jrme Schneider <typo3dev@ameos.com>
 */


class tx_ameosformidablerdtcheckbox_pi1 extends formidable_mainrenderlet
{
	function _render($aFormData = array())
	{
		// on doit rendre un groupe de controles checkboxes

		$aHtml = array();
		
		$label = $this->oForm->_getLLLabel($this->aElement["conf"]["label"]);
		$aItems = $this->_getItems($this->aElement);

		reset($aItems);
		while(list($index, $aItem) = each($aItems))
		{
			$value = $aItem["value"];
			$caption = $this->oForm->_getLLLabel($aItem["caption"]);

			// on cre le nom du controle
			$name = $this->aElement["elementname"] . "[" . $index . "]";

			$checked = "";
			$aChecked = array();

			// on rcupre la valeur soumise
			if($this->oForm->oDataHandler->_isSubmitted() || array_key_exists($this->aElement["elementname"], $aFormData))
			{
				if(is_array($aFormData[$this->aElement["elementname"]]))
				{ $aChecked = $aFormData[$this->aElement["elementname"]];}
			}
			else
			{ $aChecked = $this->_getDefaultValue();}

			if(is_array($aChecked) && in_array($value, $aChecked))
			{ $checked = " CHECKED ";}

			$aHtml[] = "<INPUT TYPE = 'CHECKBOX' NAME = '" . $name . "' ID = '" . $name . "' VALUE = '" . $value . "' " . $checked . $this->_getEvents() . "/><LABEL FOR = '" . $name . "'>" . $caption . "</LABEL>";
		}

		return $label . "<br>\n" . implode("<br>\n", $aHtml);
	}

	function _fromRenderletToDataHandler($data)
	{ return implode(",", $data);}
	
	function _fromDataHandlerToRenderlet($data)
	{ return explode(",", $data);}

	function _getHumanReadableValue($data)
	{
		$aLabels = array();
		$aItems = $this->_getItems($this->aElement);
		
		reset($data);
		while(list(, $selectedItemValue) = each($data))
		{
			reset($aItems);
			while(list(, $aItem) = each($aItems))
			{
				if($aItem["value"] == $selectedItemValue)
				{
					$aLabels[] = $this->oForm->_getLLLabel($aItem["caption"]);
					break;
				}
			}
		}
		
		return implode(", ", $aLabels);
	}
}

?>