<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Jrme Schneider (typo3dev@ameos.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'ameos_formidable_rdt_date' for the 'ameos_formidable_rdt_date' extension.
 *
 * @author	Jrme Schneider <typo3dev@ameos.com>
 */


require_once(t3lib_extMgm::extPath('rlmp_dateselectlib') . "class.tx_rlmpdateselectlib.php");

class tx_ameosformidablerdtdate_pi1 extends formidable_mainrenderlet
{
	function _render($aFormData = array())
	{
		tx_rlmpdateselectlib::includeLib();

		$aCalConf = array(	"inputFieldDateTimeFormat"	=>	$this->oForm->_navConf("/data/datetime/format/", $this->aElement));
		$dateConf = array("calConf." => $aCalConf);
		
		if($this->oForm->oDataHandler->_isSubmitted() || array_key_exists($this->aElement["elementname"], $aFormData))
		{ $value = $aFormData[$this->aElement["elementname"]];}
		else
		{ $value = $this->_getDefaultValue();}
		
		$label = $this->oForm->_getLLLabel($this->aElement["conf"]["label"]);
		$value = $this->oForm->_getLLLabel($value);

		$value = htmlspecialchars($value);

		return $label . "<br>\n<input type = \"text\" name = \"" . $this->aElement["elementname"] . "\" id = \"" . $this->aElement["elementname"] . "\" value = \"" . $value . "\"" . $this->_getEvents() . ">" . tx_rlmpdateselectlib::getInputButton($this->aElement["elementname"], $dateConf);
	}
	
	function _fromRenderletToDataHandler($data)
	{
		if(strtoupper($this->oForm->_navConf("/data/datetime/converttotimestamp/", $this->aElement)) == "TRUE")
		{
			// on convertit la date en timestamp
			// on commence par rcuprer la configuration du format de date utilis
			
			$format = $this->oForm->_navConf("/data/datetime/format/", $this->aElement);

			$this->oForm->_debug($format . " " . $data, "AMEOS_FORMIDABLE_RDT_DATE - ON CONVERTIT LA DATE EN TIMESTAMP", __LINE__, __FILE__);
			
			return $this->__strptime($data, $format);
		}

		return $data;
	}

	function _fromDataHandlerToRenderlet($data)
	{
		if(strtoupper($this->oForm->_navConf("/data/datetime/converttotimestamp/", $this->aElement)) == "TRUE")
		{
			if(intval($data) != 0)
			{
				// il s'agit d'un champ timestamp
				// on convertit le timestamp en date lisible

				$elementname = $this->oForm->_navConf("/elementname/", $this->aElement);
				$format = $this->oForm->_navConf("/data/datetime/format/", $this->aElement);


				$this->oForm->_debug($format . " " . $data, "AMEOS_FORMIDABLE_RDT_DATE - ON CONVERTIT LE TIMESTAMP EN DATE", __LINE__, __FILE__);
				
				return strftime($format, $data);
			}
			else
			{ return "";}
		}

		return $data;
	}


	function __strptime($strdate, $format)
	{
		$aAvailableTokens = array(	"%a",
									"%A",
									"%b",
									"%B",
									"%C",
									"%d",
									"%e",
									"%H",
									"%I",
									"%j",
									"%k",
									"%l",
									"%m",
									"%M",
									"%n",
									"%p",
									"%P",
									"%S",
									"%s",
									"%t",
									"%W",
									"%u",
									"%w",
									"%y",
									"%Y",
									"%%"
									);

/*
%B        full month name
%C        century number
%d        the day of the month (00 ... 31)
%e        the day of the month (0 ... 31)
%H        hour (00 ... 24)
%I        hour (01 ... 12)
%j        day of the year (000 ... 366)
%k        hour (0 ... 23)
%l        hour (1 ... 12)
%m        month (01 ... 12)
%M        mInute (00 ... 59)
%n        a newline character
%p        "PM" or "AM"
%P        "pm" or "am"
%S        second (00 ... 59)
%s        number of seconds since Unix Epoch
%t        a tab character
%W        the week number
%u        the day of the week (1 ... 7, 1 = MON)
%w        the day of the week (0 ... 6, 0 = SUN)
%y        year without the century (00 ... 99)
%Y        year including the century (eg. 1976)
%%        a literal % character 
*/
		// on dtermine les sparateurs

		$aSeparateurs = array();
		$separateurs = str_replace($aAvailableTokens, "", $format);
		
		if(count($separateurs) > 0)
		{
			for($k = 0;$k <= sizeof($separateurs);$k++)
			{
				if(!in_array($separateurs[$k], $aSeparateurs))
				{ $aSeparateurs[] = $separateurs[$k];}
			}
		}

		$aFormat = explode("#", str_replace($aSeparateurs, "#", $format));
		$aTokens = explode("#", str_replace($aSeparateurs, "#", $strdate));

		$aDate = array();
		
		foreach($aFormat as $index => $format)
		{ $aDate[$format] = $aTokens[$index];}

		reset($aDate);
		
		$day = strftime("%d");
		$month = strftime("%m");
		$year = strftime("%Y");

		if(array_key_exists("%d", $aDate))
		{ $day = $aDate["%d"];}
		elseif(array_key_exists("%e", $aDate))
		{ $day = $aDate["%e"];}

		if(array_key_exists("%m", $aDate))
		{ $month = $aDate["%m"];}
		
		if(array_key_exists("%Y", $aDate))
		{ $year = $aDate["%Y"];}

		$tstamp = mktime(0, 0, 0, $month, $day , $year);
		return $tstamp;
	}
}

?>