<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Jrme Schneider (typo3dev@ameos.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'ameos_formidable_va_std' for the 'ameos_formidable_va_std' extension.
 *
 * @author	Jrme Schneider <typo3dev@ameos.com>
 */


class tx_ameosformidablevadb_pi1 extends formidable_mainvalidator
{
	function _doTheMagic($aInfos, $aConf, $aElement, $aFormData = array())
	{
		if($this->oForm->oDataHandler->_isSubmitted())
		{
			$this->oForm->_debug(array($aInfos, $aConf, $aElement, $aFormData), "VALIDATOR DB", __LINE__, __FILE__);
			
			$aParams = $this->oForm->_navConf("/conf/", $aConf);
			
			$elementname = $this->oForm->_navConf("/elementname/", $aElement);
			$value = $aFormData[$elementname];

			if(strtoupper($this->oForm->_navConf("/unique/value/", $aParams)) == "TRUE")
			{
				// le champ est unique
				// on vrifie qu'il est bien renseign

				if(!$this->_isUnique($aElement, $value))
				{
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/unique/message/", $aParams));
					$this->oForm->_declareValidationError($elementname, "unique", $message);
				}
			}
		}
	}
	
	function _isUnique($aElement, $value)
	{
		$aDhConf = $this->oForm->_navConf("/control/datahandler/conf/");
		
		if($this->oForm->oDataHandler->_edition())
		{ $where = $aElement["elementname"] . " = '" . $value . "' and " . $aDhConf["keyname"] . " != '" . $this->oForm->oDataHandler->_edition() . "'";}
		else
		{ $where = $aElement["elementname"] . " = '" . $value . "'";}
		
		
		$db = $GLOBALS["TYPO3_DB"];
		$rSql = $db->exec_SELECTquery("count(*) as nbentries", $aDhConf["tablename"], $where);
		$rs = $db->sql_fetch_assoc($rSql);

		if($rs["nbentries"] > 0)
		{ return false;}

		return true;
	}
}

?>