<?php

	define("AMEOSFORMIDABLE_SUBMITTED", "AMEOSFORMIDABLE_SUBMITTED");	// nom utilis par mainrenderer pour placer un marqueur de soumission du formulaire
	define("AMEOSFORMIDABLE_ENTRYID", "AMEOSFORMIDABLE_ENTRYID");		// nom utilis par mainrenderer pour persister l'identifiant d'entre manipule

	class formidable_maindatahandler
	{
		var $oForm			= null;
		var $entryId		= null;
		var $aStoredData	= null;

		function _init($oForm)
		{ $this->oForm =& $oForm;}

		/**
 * Returns the slashstripped GET vars array
 *
 * @return	array		GET vars array
 * @see	formidable_maindatahandler::_GP()
 */
		function _G()
		{
			$aG = $GLOBALS["HTTP_GET_VARS"];
			t3lib_div::stripSlashesOnArray($aG);
			reset($aG);
			return $aG;
		}

		/**
 * Returns the slashstripped POST vars array
 *  merged with the _FILES vars array
 *
 * @return	array		POST vars array
 * @see	formidable_maindatahandler::_GP()
 */
		function _P()
		{
			$aP = array_merge($GLOBALS["HTTP_POST_VARS"], $this->_F());
			t3lib_div::stripSlashesOnArray($aP);
			reset($aP);
			return $aP;
		}

		/**
 * Returns the slashstripped _FILES vars array
 *
 * @return	array		_FILES vars array
 * @see	formidable_maindatahandler::_P()
 */
		function _F()
		{
			$aF = $GLOBALS["_FILES"];
			t3lib_div::stripSlashesOnArray($aF);
			reset($aF);
			return $aF;
		}

		/**
 * Returns the merged GET and POST arrays
 *  using the formidable_maindatahandler::_G() and formidable_maindatahandler::_P() functions
 *  and therefore not slashstripped
 *
 * @return	array		GET and POST vars array
 */
		function _GP()
		{
			$aGP = array_merge($this->_G(), $this->_P());
			return $aGP;
		}

		/**
 * Determines if the FORM is submitted
 *  using the AMEOSFORMIDABLE_SUBMITTED constant for naming the POSTED variable
 *
 * @return	boolean
 */
		function _isSubmitted()
		{
			$aP = $this->_P();
			return (array_key_exists(AMEOSFORMIDABLE_SUBMITTED, $aP) && $aP[AMEOSFORMIDABLE_SUBMITTED] == 1);
		}

		/**
 * Processes data returned by the HTML Form after validation, and only if validated
 * Note that this is only the 'abstract' definition of this function
 *  as it must be overloaded in the specialized DataHandlers
 *
 * @return	void
 */
		function _doTheMagic()
		{

		}

		/**
 * Returns the POST vars if submitted, or array() if not
 *
 * @return	array
 */
	function _getFormData()
	{
		if($this->_isSubmitted())
		{
			$aRs = $this->_P();
			unset($aRs[AMEOSFORMIDABLE_SUBMITTED]);
			unset($aRs[AMEOSFORMIDABLE_ENTRYID]);
			
			// le formulaire a t soumis
			// on retourne les variables issues du POST

/*			reset($aRs);
			while(list($elementname, $value) = each($aRs))
			{
				if(strtoupper($this->oForm->_navConf("/conf/renderonly/", $this->oForm->aORenderlets[$elementname]->aElement)) == "TRUE")
				{ unset($aRs[$elementname]);}
			}

			*/
			// le formulaire a t soumis
			// on retourne les variables issues du POST

			reset($aRs);
			return $aRs;
		}

		return array();
	}

	function _getFormDataManaged()
	{
		$aFormData = $this->_getFormData();
		
		reset($aFormData);
		while(list($elementname, $value) = each($aFormData))
		{
			if(strtoupper($this->oForm->_navConf("/conf/renderonly/", $this->oForm->aORenderlets[$elementname]->aElement)) == "TRUE")
			{ unset($aFormData[$elementname]);}
		}
		
		reset($aFormData);
		return $aFormData;
	}
		/**
		 * Determines if something was not validated during the validation process
		 *
		 * @return	boolean	TRUE if everything is valid, FALSE if not
		 */
		function _allIsValid()
		{ return (count($this->oForm->_aValidationErrors) == 0);}


		/**
		 * Determines if the DataHandler should work in 'edition' mode
		 * Note that this is only the 'abstract' definition of this function
		 *  in the simple case where your DataHandler should never have to edit data
		 *
		 * @return	boolean	TRUE if edition mode, FALSE if not
		 */
		function _edition()
		{ return false;}

		/**
		 * Gets the data previously stored by the DataHandler
		 * for edition
		 * Note that this is only the 'abstract' definition of this function
		 *  in the simple case where your DataHandler should never have to edit data
		 *
		 * @return	boolean	TRUE if edition mode, FALSE if not
		 * @see	formidable_maindatahandler::_edition()
		 */
		function _getStoredData()
		{ return array();}
	}

?>