<?php

	class formidable_mainrenderlet
	{
		var $oForm		= null;
		var $aElement	= null;

		function _init($oForm, $aElement)
		{
			$this->oForm		=& $oForm;
			$this->aElement		= $aElement;
		}

		function _render($aFormData = array())
		{ return $this->oForm->_getLLLabel($this->aElement["conf"]["label"]) . " Affichage par dfaut";}

	/**
	 * [Describe function...]
	 *
	 * @return	[type]		...
	 */
		function _getDefaultValue()
		{
			$value = $this->oForm->_navConf("/data/defaultvalue/", $this->aElement);

			if(is_array($value))
			{
				// on vrifie si on doit appeler un userobj pour rcuprer la valeur par dfaut

				if($this->oForm->_navConf("/userobj/", $value) !== false)
				{ $defaultvalue = $this->_callUserObj($this->aElement, $value, null);}
				else
				{ $defaultvalue = "";}
			}
			else
			{ $defaultvalue = $value;}

			switch($defaultvalue)
			{
				case "CURRENT_TIMESTAMP" :
				{
					$defaultvalue = time();
					break;
				}
				case "CURRENT_PAGEID" :
				{
					// front end only

					$defaultvalue = $GLOBALS["TSFE"]->id;
					break;
				}
				case "CURRENT_USERID" :
				{
					// front end only

					$defaultvalue = $GLOBALS["TSFE"]->fe_user->user["uid"];
					break;
				}
			}

			return $defaultvalue;
		}

	/**
	 * [Describe function...]
	 *
	 * @return	[type]		...
	 */
		function _getEvents()
		{
			$aHtml = array();

			// complete list of html INPUT events (IExplore !!)
			// see http://msdn.microsoft.com/library/default.asp?url=/workshop/author/dhtml/reference/objects/input_text.asp

			$aEvents = array(
			"onactivate",			// Fires when the object is set as the active element.
			"onafterupdate",		// Fires on a databound object after successfully updating the associated data in the data source object.
			"onbeforeactivate",		// Fires immediately before the object is set as the active element.
			"onbeforecut",			// Fires on the source object before the selection is deleted from the document.
			"onbeforedeactivate",	// Fires immediately before the activeElement is changed from the current object to another object in the parent document.
			"onbeforeeditfocus",	// Fires before an object contained in an editable element enters a UI-activated state or when an editable container object is control selected.
			"onbeforepaste",		// Fires on the target object before the selection is pasted from the system clipboard to the document.
			"onbeforeupdate",		// Fires on a databound object before updating the associated data in the data source object.
			"onblur",				// Fires when the object loses the input focus.
			"onchange",				// Fires when the contents of the object or selection have changed.
			"onclick",				// Fires when the user clicks the left mouse button on the object.
			"oncontextmenu",		// Fires when the user clicks the right mouse button in the client area, opening the context menu.
			"oncontrolselect",		// Fires when the user is about to make a control selection of the object.
			"oncut",				// Fires on the source element when the object or selection is removed from the document and added to the system clipboard.
			"ondblclick",			// Fires when the user double-clicks the object.
			"ondeactivate",			// Fires when the activeElement is changed from the current object to another object in the parent document.
			"ondrag",				// Fires on the source object continuously during a drag operation.
			"ondragend",			// Fires on the source object when the user releases the mouse at the close of a drag operation.
			"ondragenter",			// Fires on the target element when the user drags the object to a valid drop target.
			"ondragleave",			// Fires on the target object when the user moves the mouse out of a valid drop target during a drag operation.
			"ondragover",			// Fires on the target element continuously while the user drags the object over a valid drop target.
			"ondragstart",			// Fires on the source object when the user starts to drag a text selection or selected object.
			"ondrop",				// Fires on the target object when the mouse button is released during a drag-and-drop operation.
			"onerrorupdate",		// Fires on a databound object when an error occurs while updating the associated data in the data source object.
			"onfilterchange",		// Fires when a visual filter changes state or completes a transition.
			"onfocus",				// Fires when the object receives focus.
			"onfocusin",			// Fires for an element just prior to setting focus on that element.
			"onfocusout",			// Fires for the current element with focus immediately after moving focus to another element.
			"onhelp",				// Fires when the user presses the F1 key while the browser is the active window.
			"onkeydown",			// Fires when the user presses a key.
			"onkeypress",			// Fires when the user presses an alphanumeric key.
			"onkeyup",				// Fires when the user releases a key.
			"onlosecapture",		// Fires when the object loses the mouse capture.
			"onmousedown",			// Fires when the user clicks the object with either mouse button.
			"onmouseenter",			// Fires when the user moves the mouse pointer into the object.
			"onmouseleave",			// Fires when the user moves the mouse pointer outside the boundaries of the object.
			"onmousemove",			// Fires when the user moves the mouse over the object.
			"onmouseout",			// Fires when the user moves the mouse pointer outside the boundaries of the object.
			"onmouseover",			// Fires when the user moves the mouse pointer into the object.
			"onmouseup",			// Fires when the user releases a mouse button while the mouse is over the object.
			"onmousewheel",			// Fires when the wheel button is rotated.
			"onmove",				// Fires when the object moves.
			"onmoveend",			// Fires when the object stops moving.
			"onmovestart",			// Fires when the object starts to move.
			"onpaste",				// Fires on the target object when the user pastes data, transferring the data from the system clipboard to the document.
			"onpropertychange",		// Fires when a property changes on the object.
			"onreadystatechange",	// Fires when the state of the object has changed.
			"onresize",				// Fires when the size of the object is about to change.
			"onresizeend",			// Fires when the user finishes changing the dimensions of the object in a control selection.
			"onresizestart",		// Fires when the user begins to change the dimensions of the object in a control selection.
			"onselect",				// Fires when the current selection changes.
			"onselectstart",		// Fires when the object is being selected.
			"ontimeerror",			// Fires whenever a time-specific error occurs, usually as a result of setting a property to an invalid value.
			);

			reset($aEvents);
			while(list(, $eventname) = each($aEvents))
			{
				$eventvalue	= $this->oForm->_navConf("/conf/" . $eventname . "/", $this->aElement);

				if($eventvalue)
				{ $aHtml[] =  $eventname . " = \"" . $eventvalue . "\"";}
			}

			$custom = $this->oForm->_navConf("/conf/custom/", $this->aElement);
			if($custom)
			{ $aHtml[] = " " . $custom . " ";}

			return " " . implode(" ", $aHtml) . " ";
		}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$aElement: ...
	 * @return	[type]		...
	 */
		function _getItems($aElement)
		{
			$aItems = array();
			$aXmlItems = array();
			$aUserItems = array();

			$aXmlItems = $this->oForm->_navConf("/data/items/", $aElement);

			if($aXmlItems === false)
			{ $aXmlItems = array();}

			$aUserItems = $this->_callUserObj($aElement, $this->oForm->_navConf("/data/", $aElement), $aXmlItems);
			$aItems = $this->_callUserObjMergeItems($aXmlItems, $aUserItems);

			if(is_array($aItems) && count($aItems) > 0)
			{
				reset($aItems);
				return $aItems;
			}

			return array();
		}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$aElement: ...
	 * @param	[type]		$aUserobj: ...
	 * @param	[type]		$aData: ...
	 * @return	[type]		...
	 */
		function _callUserObj($aElement, $aUserobj, $aData)
		{
			if(is_array($this->oForm->_navConf("/userobj/", $aUserobj)))
			{
				$extension = $this->oForm->_navConf("/userobj/extension/", $aUserobj);
				$method = $this->oForm->_navConf("/userobj/method/", $aUserobj);

				$aParams = array();
				$aUserObjParams = $this->oForm->_navConf("/userobj/params/", $aUserobj);

				if(is_array($aUserObjParams))
				{
					while(list($index, $aParam) = each($aUserObjParams))
					{
						$name = $aParam["name"];
						$value = $aParam["value"];

						$aParams[$name] = $value;
					}
					reset($aParams);
				}

				$oExtension = t3lib_div::makeInstance($extension);
				if(is_object($oExtension))
				{
					if(method_exists($oExtension, $method))
					{
						$newData = $oExtension->{$method}($aData, $aParams, $this->oForm);
						$this->oForm->_debug($newData, "RESULT OF " . $extension . "->" . $method . "()", __LINE__, __FILE__);

						return $newData;
					}
					else
					{ $this->oForm->mayday("RENDERLET " . $this->oForm->_navConf("/type/", $aElement) . " <b>" . $this->oForm->_navConf("/elementname/", $aElement) . "</b> : callback method <b>" . $method . "</b> of the Object <b>" . $extension . "</b> doesn't exist");}
				}
			}

			return $aData;
		}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$aXmlItems: ...
	 * @param	[type]		$aUserItems: ...
	 * @return	[type]		...
	 */
		function _callUserObjMergeItems($aXmlItems, $aUserItems)
		{
			$aItems = array_merge($aXmlItems, $aUserItems);

			if(is_array($aItems) && sizeof($aItems) > 0)
			{
				reset($aItems);
				return $aItems;
			}

			return array();
		}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$data: ...
	 * @return	[type]		...
	 */
		function _fromDataHandlerToRenderlet($data)
		{
			return $data;
		}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$data: ...
	 * @return	[type]		...
	 */
		function _fromRenderletToDataHandler($data)
		{
			return html_entity_decode($data);
		}

		function _getHumanReadableValue($data)
		{ return $data;}
	}

?>