<?php

	class formidable_mainvalidator
	{
		var $oForm	= null;

		function _init($oForm)
		{ $this->oForm =& $oForm;}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$aInfos: ...
	 * @param	[type]		$aConf: ...
	 * @param	[type]		$aElement: ...
	 * @param	[type]		$aFormData: ...
	 * @return	[type]		...
	 */
		function _doTheMagic($aInfos, $aConf, $aElement, $aFormData = array())
		{
			$aParams = $this->oForm->_navConf("/conf/", $aConf);

			$elementname = $this->oForm->_navConf("/elementname/", $aElement);
			$value = $aFormData[$elementname];
			
			if(strtoupper($this->oForm->_navConf("/required/value/", $aParams)) == "TRUE")
			{
				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][required] on '" . $aElement["elementname"] . "', TYPE [" . $aElement["type"] . "]", __LINE__, __FILE__);

				// le champ est obligatoire
				// on vrifie qu'il est bien renseign

				if($this->_isEmpty($aElement, $value))
				{
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/required/message/", $aParams));
					$this->oForm->_declareValidationError($elementname, "required", $message);
				}
			}

			if(intval($this->oForm->_navConf("/maxsize/value/", $aParams) != 0))
			{
				$maxsize = intval($this->oForm->_navConf("/maxsize/value/", $aParams));
				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][maxsize = '" . $maxsize . "'] on '" . $aElement["elementname"] . "', TYPE [" . $aElement["type"] . "]", __LINE__, __FILE__);

				// le champ est obligatoire
				// on vrifie qu'il est bien renseign

				if($this->_isTooLong($aElement, $value, $maxsize))
				{
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/maxsize/message/", $aParams));
					$this->oForm->_declareValidationError($elementname, "maxsize", $message);
				}
			}

			if(trim($this->oForm->_navConf("/sameas/value/", $aParams)) != "")
			{
				$sameas = trim($this->oForm->_navConf("/sameas/value/", $aParams));

				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][sameas '" . $sameas . "'] on '" . $aElement["elementname"] . "', TYPE [" . $aElement["type"] . "]", __LINE__, __FILE__);
				// le champ doit tre identique  un autre champ
				// on vrifie

				if(!$this->_isSameAs($value, $aFormData[$sameas]))
				{
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/sameas/message/", $aParams));
					$this->oForm->_declareValidationError($elementname, "sameas", $message);
				}
			}

			if(strtoupper($this->oForm->_navConf("/email/value/", $aParams)) == "TRUE")
			{
				$this->oForm->_debug(null, "VALIDATOR[" . $aInfos["TYPE"] . "][email '" . $value . "'] on '" . $aElement["elementname"] . "', TYPE [" . $aElement["type"] . "]", __LINE__, __FILE__);

				// le champ est obligatoire
				// on vrifie qu'il est bien renseign

				if(!$this->_isEmail($aElement, $value))
				{
					$message = $this->oForm->_getLLLabel($this->oForm->_navConf("/email/message/", $aParams));
					$this->oForm->_declareValidationError($elementname, "email", $message);
				}
			}
		}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$aElement: ...
	 * @param	[type]		$value: ...
	 * @return	[type]		...
	 */
		function _isEmpty($aElement, $value)
		{
			if(is_array($value))
			{
				// les lments srialiss de type multiple
				return (count($value) == 0);
			}
			else
			{ return (strlen(trim($value)) == 0);}
		}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$aElement: ...
	 * @param	[type]		$value: ...
	 * @param	[type]		$maxSize: ...
	 * @return	[type]		...
	 */
		function _isTooLong($aElement, $value, $maxSize)
		{
			if(is_array($value))
			{
				// les lments srialiss de type multiple
				return (count($value) > $maxSize);
			}
			else
			{ return (strlen(trim($value)) > $maxSize);}
		}

		function _isSameAs($value1, $value2)
		{ return ($value1 === $value2);}

		function _isEmail($aElement, $value)
		{ return t3lib_div::validEmail($value);}
	}

?>